import { F, S2D, V2, V3 } from "@thi.ng/shader-ast/api/types";
import { defn, ret } from "@thi.ng/shader-ast/ast/function";
import { vec2, vec3 } from "@thi.ng/shader-ast/ast/lit";
import { add, sub } from "@thi.ng/shader-ast/ast/ops";
import { sym } from "@thi.ng/shader-ast/ast/sym";
import { $x, $y } from "@thi.ng/shader-ast/ast/swizzle";
import { normalize } from "@thi.ng/shader-ast/builtin/math";
import { texture } from "@thi.ng/shader-ast/builtin/texture";
const sample1 = (tex, uv, unit) => sub($x(texture(tex, sub(uv, unit))), $x(texture(tex, add(uv, unit))));
const normal2 = defn(
  V3,
  null,
  [S2D, V2, V2, F, F],
  (tex, uv, step, z, eps) => {
    let sx;
    let sy;
    return [
      sx = sym(vec2($x(step), 0)),
      sy = sym(vec2(0, $y(step))),
      ret(
        normalize(
          add(
            vec3(sample1(tex, uv, sx), sample1(tex, uv, sy), z),
            eps
          )
        )
      )
    ];
  }
);
export {
  normal2
};
